//============================================================================
// Name        : main.cpp
// Author      : Ruediger Knoerig
// Version     :
// Copyright   : GPL
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include "cv.h"
#include "highgui.h"
#include <string>
#include <vector>
#include <cmath>

using namespace std;
using namespace cv;

const int MaxMark=100;
// Test
int main() {
  try {
    TermCriteria oftc = TermCriteria( CV_TERMCRIT_ITER | CV_TERMCRIT_EPS, 20, .3 );
    VideoCapture cap(0); // open the default camera
    if (!cap.isOpened()) throw string("Konnte keine Kamera aktivieren!");
    Mat bild,graustufen[2];
    int cptr=0;
    namedWindow("Anzeige", 1);
    vector<Point2f>  markierung;
    vector<Point2f>  markWeiter;
    vector<uchar> erfolg;
    vector<float> fehler;
    cap >> bild;
    cvtColor(bild, graustufen[cptr^=1], CV_BGR2GRAY);
    for (;;) {
      cap >> bild; // get a new frame from camera
      cvtColor(bild, graustufen[cptr^=1], CV_BGR2GRAY);
      //GaussianBlur( graustufen[cptr], graustufen[cptr],Size(9,9), 2, 2 );
      goodFeaturesToTrack(graustufen[cptr],markierung,MaxMark,0.01,1);
      for( size_t i = 0; i < markierung.size(); i++ )
	{
	  circle(bild, Point(markierung[i].x, markierung[i].y),4,Scalar(0,255,0));
	}
      calcOpticalFlowPyrLK(graustufen[cptr ^ 1],graustufen[cptr],markierung,markWeiter,erfolg,fehler,Size(15, 15),3,oftc);
      for( size_t i = 0; i < markierung.size(); i++ )
	{
	  if(erfolg[i])
	    {
	      Point2f p=markierung[i];
	      Point2f q=markWeiter[i];
	      Point2f d=q-p;
	      Point2f pfeil1(d.x*cos(M_PI*160.0/180.0)-d.y*sin(M_PI*160.0/180.0),d.x*sin(M_PI*160.0/180.0)+d.y*cos(M_PI*160.0/180.0));
	      Point2f pfeil2(d.x*cos(M_PI*200.0/180.0)-d.y*sin(M_PI*200.0/180.0),d.x*sin(M_PI*200.0/180.0)+d.y*cos(M_PI*200.0/180.0));
	      q=p+2*d;
	      line(bild,p,q,Scalar(0,0,255));
	      line(bild,q,q+0.8*pfeil1,Scalar(0,0,255));
	      line(bild,q,q+0.8*pfeil2,Scalar(0,0,255));
	    }
	}
      imshow("Anzeige",bild);
      if (waitKey(30) >= 0)
	break;
    }
    vector<int> attribute(2);
    attribute[0] = CV_IMWRITE_JPEG_QUALITY;
    attribute[1] = 90;
    imwrite(string("Bild.jpg"), bild, attribute);
    return 0;
  } catch (string msg) {
    cerr << "Ein Fehler ist aufgetreten!" << endl << msg << endl;
    return -1;
  }
}

